/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4; coding: utf-8 -*- */
#ifndef __IMAGE_VIEW_DRAWER_H__
#define __IMAGE_VIEW_DRAWER_H__

#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include "utils.h"

typedef enum
{
    DRAW_FLAGS_ALLOCATE = 1,
    DRAW_FLAGS_SCALE = 2
} DrawFlags;

typedef struct
{
    gdouble        zoom;

    /* Offset in the image in zoom-space coordinates. */
    Pos            pos;
    GdkInterpType  interp;
    GdkPixbuf     *pixbuf;

    /* Rectangle in widget-space coordinates to redraw. */
    GdkRectangle   rect;

    /* The two colors to use to draw the checker board. */
    int            check_color1;
    int            check_color2;
} DrawSettings;

typedef struct 
{
    GdkPixbuf     *last_pixbuf;
    DrawSettings   old;

    int            check_size;
} ImageViewDrawer;

DrawFlags        draw_settings_get_flags (DrawSettings *last,
                                          DrawSettings *new,
                                          GdkPixbuf    *last_pixbuf);
ImageViewDrawer *image_view_drawer_new  (void);
void             image_view_drawer_free (ImageViewDrawer *drawer);
void             image_view_drawer_force_scale (ImageViewDrawer *drawer);
void             image_view_drawer_draw (ImageViewDrawer *drawer,
                                         DrawSettings    *settings,
                                         GdkDrawable     *drawable);

#endif
